/**
* ...
* @author Dani Llops
* @version 0.1
*/

package{
	import flash.display.*;
	import flash.events.*;
	import flash.filters.GlowFilter;
	import flash.geom.ColorTransform;
	import com.llops.utils.FPS;
	import com.llops.utils.Random;
	import flash.utils.Timer;
	import Pixel;
	
	public class Main extends Sprite
	{		
		// MC en el escenario
		public var marco_mc:MovieClip;
		public var mensaje_mc:MovieClip;
		
		// Medidas escenario
		public static var ANCHO:int = 300;
		public static var ALTO:int = 250;
		
		// Bitmap
		private var _bmpData:BitmapData = new BitmapData(ANCHO, ALTO, true, 0);
		private var _bmp:Bitmap = new Bitmap(_bmpData);
		
		// Colores
		public const BLANCO:uint = 0xFFFFFFFF;
		public const AZULADO:uint = 0xFF006699;
		
		private var _color_pixel:uint = BLANCO;
		private var _color_glow:uint = AZULADO;
		
		
		// Variables
		private var _cont:int = 0;
		private var _init:Boolean = false;
		private var _pixels:Array = new Array();
		
		// Variables para controlar los pixels
		private var _max_pixels:int = 4000;
		
		// Color transform para el fade
		private var _ct:ColorTransform = new ColorTransform();
		
		// Variable para la pausa
		private var _timer_pausa:Timer;		
		
		
		function Main() 
		{
			// Aadir el bitmap
			addChild(_bmp);
			
			// Poner el marco por encima de todo
			addChild(marco_mc);
			
			// Aadir Medidor de frames por segundo
			var fps:FPS = new FPS();
			fps.x = 10;
			fps.y = 10;
			addChild(fps);
			
			// Fijar el nivel de alfa para el Fade
			_ct.alphaMultiplier = .92;
			
			// Crear y aplicar el filtro Glow
			var _glow:GlowFilter = new GlowFilter(_color_glow, 1, 4, 4);
			_bmp.filters = [_glow];
			
			// BlenMode
			_bmp.blendMode = BlendMode.ADD;
			
			// Eventos
			stage.addEventListener(Event.ENTER_FRAME, render);
			stage.addEventListener(MouseEvent.CLICK, iniciar);
			stage.addEventListener(Event.MOUSE_LEAVE, pausar);
			
			// Genera todos los pixels
			crearPixels();
		}
		
		private function iniciar(e:MouseEvent):void
		{
			if (!_init) {
				mensaje_mc.visible = false;
				_init = true;
				_bmp.visible = true;
			}
		}
		
		private function crearPixels():void 
		{
			for (var i:int = 0; i < _max_pixels; i++) 
			{
				var posx:int = Random.obtenerEntero(0, ANCHO);
				var posy:int = Random.obtenerEntero(0, ALTO);
				_pixels.unshift(new Pixel(_cont, posx, posy));
				_cont++;
			}
		}
		
		private function render(e:Event):void 
		{
			if (_init)
			{
				for (var a:String in _pixels) 
				{
					var p:Pixel = _pixels[a];
					p.mover();
					_bmpData.setPixel32(p.x, p.y, _color_pixel);
					
					// Comprobar limites
					if (p.y > ALTO){
						p.y = 0;
					}else if (p.y < 0){
						p.y = ALTO;
					}else if (p.x < 0){
						p.x = ANCHO;
					}else if (p.x > ANCHO){
						p.x = 0;
					}
				}
				
				// Aplicar Fade
				_bmpData.colorTransform(_bmpData.rect, _ct);
				
				//trace("Longitud:", _pixels.length);		
			}
		}
		
		private function eliminarPixel(p:Pixel):void
		{
			var long:int = _pixels.length;
			for (var i:int = 0; i < long; i++) 
			{
				if (p == _pixels[i])
				{
					//trace("Eliminar", p.name);
					_pixels.splice(i, 1);
				}
			}
		}
		
		// --
		// Mtodos para la PAUSA
		// --
		private function pausar(e:Event):void 
		{
			//trace("Peticion pausar");
			_timer_pausa = new Timer(1000, 1);
			_timer_pausa.addEventListener(TimerEvent.TIMER_COMPLETE, function():void 
				{
					if (_init) {
						//trace("Pausa Activa");
						_bmp.visible = false;
						_init = false;
						mensaje_mc.visible = true;
					}
				});
			_timer_pausa.start();
			stage.addEventListener(MouseEvent.MOUSE_MOVE, despausar);
		}
		
		private function despausar(e:MouseEvent):void 
		{
			//trace("desPausa");
			_timer_pausa.stop();
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, despausar);
		}
	}
}